<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-05-30 16:49:04Z
 */
 
/**
 * @note THIS FILE WAS GENERATED AUTOMATICALLY. DO NOT MODIFY IT. YOUR CHANGES WILL
 * BE LOST. INSTEAD MODIFY CONCRETE IMPLEMENTATION OF THIS CLASS.
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011-2012 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Wed, 30 May 2012 11:12:42 +0300
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CREditionArticle extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $sortOrder = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 255
     */
    public $code = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRArticle
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRArticle")
     * @mandatory 0
     * @destination_entity CRArticle
     * @to_many 0
     * @name toArticle
     */
    public $toArticle = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRToDo
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRToDo")
     * @mandatory 1
     * @destination_entity CRToDo
     * @to_many 0
     * @name toEdition
     */
    public $toEdition = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("editionArticleID");
        $entityConfiguration->setName("CREditionArticle");
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CREditionArticle
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set sortOrder.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CREditionArticle
     */
    public function setSortOrder($value)
    {
        $this->sortOrder = $value;
        return $this;
    }

    /**
     * Get sortOrder.
     *
     * @return integer
     */
    public function getSortOrder()
    {
        return $this->sortOrder;
    }

    /**
     * Set code.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CREditionArticle
     */
    public function setCode($value)
    {
        $this->code = $value;
        return $this;
    }

    /**
     * Get code.
     *
     * @return string
     */
    public function getCode()
    {
        return $this->code;
    }

    /**
     * Set toArticle.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRArticle $value
     * @return Carerix_Api_Rest_Entity_Abstract_CREditionArticle
     */
    public function setToArticle($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRArticle($value); 
        }                 
        $this->toArticle = $value;
        return $this;
    }

    /**
     * Get toArticle.
     *
     * @return Carerix_Api_Rest_Entity_CRArticle
     */
    public function getToArticle()
    {
        return $this->toArticle;
    }

    /**
     * Set toEdition.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRToDo $value
     * @return Carerix_Api_Rest_Entity_Abstract_CREditionArticle
     */
    public function setToEdition($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRToDo($value); 
        }                 
        $this->toEdition = $value;
        return $this;
    }

    /**
     * Get toEdition.
     *
     * @return Carerix_Api_Rest_Entity_CRToDo
     */
    public function getToEdition()
    {
        return $this->toEdition;
    }


}