<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-05-30 16:49:04Z
 */
 
/**
 * @note THIS FILE WAS GENERATED AUTOMATICALLY. DO NOT MODIFY IT. YOUR CHANGES WILL
 * BE LOST. INSTEAD MODIFY CONCRETE IMPLEMENTATION OF THIS CLASS.
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011-2012 Carerix (http://www.carerix.com). All rights
 * reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Wed, 30 May 2012 11:12:52 +0300
 */
abstract class Carerix_Api_Rest_Entity_Abstract_CRNodeType extends Carerix_Api_Rest_Entity
{

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $typeID = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 0
     * @width 32
     */
    public $name = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 16
     * @isUnique 1
     */
    public $importID = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isEnumerated = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 1
     * @value_type i
     * @value_type_human long integer (32 bits)
     */
    public $currentEnumerationID = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $deleted = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isEditable = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width
     */
    public $localizedName = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isExtracted = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 32
     */
    public $identifier = null;

    /**
     * @access private
     * @var string
     * @value_class NSString
     * @allows_null 1
     * @width 1000000
     */
    public $notesDescription = null;

    /**
     * @access private
     * @var integer
     * @value_class NSNumber
     * @allows_null 0
     * @value_type s
     * @value_type_human short integer (16 bits)
     */
    public $isMultiLanguage = null;

    /**
     * @access private
     * @var Carerix_Api_Rest_Collection
     * @OneToMany (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory 0
     * @destination_entity CRDataNode
     * @to_many 1
     * @name dataNodes
     */
    public $dataNodes = null;

    public static function configure(Carerix_Api_Rest_EntityConfiguration $entityConfiguration)
    {
        parent::configure($entityConfiguration);
        $entityConfiguration->setIdentifierKey("nodeTypeID");
        $entityConfiguration->setName("CRNodeType");
    }

    /**
     * Set typeID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setTypeID($value)
    {
        $this->typeID = $value;
        return $this;
    }

    /**
     * Get typeID.
     *
     * @return integer
     */
    public function getTypeID()
    {
        return $this->typeID;
    }

    /**
     * Set name.
     *
     * Provides a fluent interface.
     *
     * @param string $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setName($value)
    {
        $this->name = $value;
        return $this;
    }

    /**
     * Get name.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Set importID.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setImportID($value)
    {
        $this->importID = $value;
        return $this;
    }

    /**
     * Get importID.
     *
     * @return string
     */
    public function getImportID()
    {
        return $this->importID;
    }

    /**
     * Set isEnumerated.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setIsEnumerated($value)
    {
        $this->isEnumerated = $value;
        return $this;
    }

    /**
     * Get isEnumerated.
     *
     * @return integer
     */
    public function getIsEnumerated()
    {
        return $this->isEnumerated;
    }

    /**
     * Set currentEnumerationID.
     *
     * Provides a fluent interface.
     *
     * @param integer $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setCurrentEnumerationID($value)
    {
        $this->currentEnumerationID = $value;
        return $this;
    }

    /**
     * Get currentEnumerationID.
     *
     * @return integer
     */
    public function getCurrentEnumerationID()
    {
        return $this->currentEnumerationID;
    }

    /**
     * Set deleted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setDeleted($value)
    {
        $this->deleted = $value;
        return $this;
    }

    /**
     * Get deleted.
     *
     * @return integer
     */
    public function getDeleted()
    {
        return $this->deleted;
    }

    /**
     * Set isEditable.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setIsEditable($value)
    {
        $this->isEditable = $value;
        return $this;
    }

    /**
     * Get isEditable.
     *
     * @return integer
     */
    public function getIsEditable()
    {
        return $this->isEditable;
    }

    /**
     * Set localizedName.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setLocalizedName($value)
    {
        $this->localizedName = $value;
        return $this;
    }

    /**
     * Get localizedName.
     *
     * @return string
     */
    public function getLocalizedName()
    {
        return $this->localizedName;
    }

    /**
     * Set isExtracted.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setIsExtracted($value)
    {
        $this->isExtracted = $value;
        return $this;
    }

    /**
     * Get isExtracted.
     *
     * @return integer
     */
    public function getIsExtracted()
    {
        return $this->isExtracted;
    }

    /**
     * Set identifier.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setIdentifier($value)
    {
        $this->identifier = $value;
        return $this;
    }

    /**
     * Get identifier.
     *
     * @return string
     */
    public function getIdentifier()
    {
        return $this->identifier;
    }

    /**
     * Set notesDescription.
     *
     * Provides a fluent interface.
     *
     * @param string $value [optional]
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setNotesDescription($value)
    {
        $this->notesDescription = $value;
        return $this;
    }

    /**
     * Get notesDescription.
     *
     * @return string
     */
    public function getNotesDescription()
    {
        return $this->notesDescription;
    }

    /**
     * Set isMultiLanguage.
     *
     * Provides a fluent interface.
     *
     * @param integer $value
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setIsMultiLanguage($value)
    {
        $this->isMultiLanguage = $value;
        return $this;
    }

    /**
     * Get isMultiLanguage.
     *
     * @return integer
     */
    public function getIsMultiLanguage()
    {
        return $this->isMultiLanguage;
    }

    /**
     * Set dataNodes.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Collection $values
     * @return Carerix_Api_Rest_Entity_Abstract_CRNodeType
     */
    public function setDataNodes($values)
    {
        if(is_array($values)) {
            $values = new Carerix_Api_Rest_Collection($values, 'Carerix_Api_Rest_Entity_CRDataNode'); 
        } 
        $this->dataNodes = $values;
        return $this;
    }

    /**
     * Get dataNodes.
     *
     * @param $index [optional] integer get an item at specified index
     * @return Carerix_Api_Rest_Collection|Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getDataNodes($index = null)
    {
        if($index !== null) {
            return $this->dataNodes[$index];
        }
        return $this->dataNodes;
    }


}