<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-05-30 16:49:04Z
 */
 
/**
 * @category Carerix
 * @licence http://www.opensource.org/licenses/lgpl-license.php LGPL
 * @link http://www.carerix.com
 * @copyright Copyright 2011 Carerix (http://www.carerix.com). All rights reserved.
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @version Fri, 23 Sep 2011 10:20:53 +0300
 */
class Carerix_Api_Rest_Entity_CREmployee extends Carerix_Api_Rest_Entity_Abstract_CREmployee
{
    
    /**
     * fullAddress
     * @var string
     */
    public $fullAddress;
    
    /**
     * Gets fullAddress
     *
     * @return string
     */
    public function getFullAddress() 
    {
        return $this->fullAddress;
    }
    
    /**
     * Sets fullAddress
     *
     * @param string $fullAddress fullAddress
     * @return self
     */
    public function setFullAddress($fullAddress) 
    {
        $this->fullAddress = $fullAddress;
        return $this;
    }
    
    
    /**
     * city
     * @access private 
     * @var string
     */
    public $city;
    
    /**
     * Gets city
     *
     * @return string
     */
    public function getCity() 
    {
        return $this->city;
    }
    
    /**
     * Sets city
     *
     * @param string $city city
     * @return self
     */
    public function setCity($city) 
    {
        $this->city = $city;
        return $this;
    }    
    
    
    
    /**
     * emailAddress
     * @var string
     * @access private
     * @alias toUser.emailAddresses[0].emailAddress
     */
    public $emailAddress;
    
    /**
     * Gets emailAddress
     *
     * @return string
     */
    public function getEmailAddress() 
    {
        return $this->emailAddress;
    }
    
    /**
     * Sets emailAddress
     *
     * @param string $emailAddress emailAddress
     * @return self
     */
    public function setEmailAddress($emailAddress) 
    {
        $this->emailAddress = $emailAddress;
        return $this;
    }
    
    /**
     * emailAddressBusiness
     * @access private
     * @var string
     */
    public $emailAddressBusiness;
    
    /**
     * Gets emailAddressBusiness
     *
     * @return string
     */
    public function getEmailAddressBusiness() 
    {
        return $this->emailAddressBusiness;
    }
    
    /**
     * Sets emailAddressBusiness
     *
     * @param string $emailAddressBusiness emailAddressBusiness
     * @return self
     */
    public function setEmailAddressBusiness($emailAddressBusiness) 
    {
        $this->emailAddressBusiness = $emailAddressBusiness;
        return $this;
    }
    
    /**
     * phoneNumberBusiness
     * @access private
     * @var string
     */
    public $phoneNumberBusiness;
    
    /**
     * Gets phoneNumberBusiness
     *
     * @return string
     */
    public function getPhoneNumberBusiness() 
    {
        return $this->phoneNumberBusiness;
    }
    
    /**
     * Sets phoneNumberBusiness
     *
     * @param string $phoneNumberBusiness phoneNumberBusiness
     * @return self
     */
    public function setPhoneNumberBusiness($phoneNumberBusiness) 
    {
        $this->phoneNumberBusiness = $phoneNumberBusiness;
        return $this;
    }
    
    /**
     * phoneNumber
     * @access private
     * @var string
     */
    public $phoneNumber;
    
    /**
     * Gets phoneNumber
     *
     * @return string
     */
    public function getPhoneNumber() 
    {
        return $this->phoneNumber;
    }
    
    /**
     * Sets phoneNumber
     *
     * @param string $phoneNumber phoneNumber
     * @return self
     */
    public function setPhoneNumber($phoneNumber) 
    {
        $this->phoneNumber = $phoneNumber;
        return $this;
    }
    
    /**
     * mobileNumber
     * @access private
     * @var string
     */
    public $mobileNumber;
    
    /**
     * Gets mobileNumber
     *
     * @return string
     */
    public function getMobileNumber() 
    {
        return $this->mobileNumber;
    }
    
    /**
     * Sets mobileNumber
     *
     * @param string $mobileNumber mobileNumber
     * @return self
     */
    public function setMobileNumber($mobileNumber) 
    {
        $this->mobileNumber = $mobileNumber;
        return $this;
    }
    
    /**
     * mobileNumberBusiness
     * @access private
     * @var string
     */
    public $mobileNumberBusiness;
    
    /**
     * Gets mobileNumberBusiness
     *
     * @return string
     */
    public function getMobileNumberBusiness() 
    {
        return $this->mobileNumberBusiness;
    }
    
    /**
     * Sets mobileNumberBusiness
     *
     * @param string $mobileNumberBusiness mobileNumberBusiness
     * @return self
     */
    public function setMobileNumberBusiness($mobileNumberBusiness) 
    {
        $this->mobileNumberBusiness = $mobileNumberBusiness;
        return $this;
    }
    
    /**
     * firstName
     * @access private
     * @var string
     */
    public $firstName;
    
    /**
     * Gets firstName
     *
     * @return string
     */
    public function getFirstName() 
    {
        return $this->firstName;
    }
    
    /**
     * Sets firstName
     *
     * @param string $firstName firstName
     * @return self
     */
    public function setFirstName($firstName) 
    {
        $this->firstName = $firstName;
        return $this;
    }
    
    /**
     * lastName
     * @access private
     * @var string
     */
    public $lastName;
    
    /**
     * Gets lastName
     *
     * @return string
     */
    public function getLastName() 
    {
        return $this->lastName;
    }
    
    /**
     * Sets lastName
     *
     * @param string $lastName lastName
     * @return self
     */
    public function setLastName($lastName) 
    {
        $this->lastName = $lastName;
        return $this;
    }
    
    /**
     * @access private
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode")
     * @mandatory ?
     * @destination-entity CRDataNode
     * @to-many 0
     * @name toCountryNode
     * @qualifier 
     * @default 
     * @nodeType 
     */
    public $toCountryNode = null;
    
    /**
     * Gets toCountryNode
     *
     * @return Carerix_Api_Rest_Entity_CRDataNode
     */
    public function getToCountryNode() 
    {
        return $this->toCountryNode;
    }
    
    /**
     * Sets toCountryNode
     *
     * @param Carerix_Api_Rest_Entity_CRDataNode $toCountryNode toCountryNode
     * @return self
     */
    public function setToCountryNode($toCountryNode) 
    {
        $this->toCountryNode = $toCountryNode;
        return $this;
    }
    
    
    /**
     * @var Carerix_Api_Rest_Entity_CRDataNode
     * @OneToOne (targetEntity="Carerix_Api_Rest_Entity_CRDataNode", mappedTo="CREmployee.toUser.toSingleStatusNode")
     * 
     * @access private
     */
    public $toStatusNode = null;
    
    /**
     * Set toStatusNode.
     *
     * Provides a fluent interface.
     *
     * @param array|Carerix_Api_Rest_Entity_CRDataNode $value
     * @return Carerix_Api_Rest_Entity_Abstract_Employee
     */
    public function setToStatusNode($value)
    {
        if(is_array($value)) {
            $value = new Carerix_Api_Rest_Entity_CRDataNode($value); 
        }                 
        $this->toStatusNode = $value;
        return $this;
    }

    /**
     * Get toStatusNode.
     *
     * @return Carerix_Api_Rest_Entity_Data_Node
     */
    public function getToStatusNode()
    {
        return $this->toStatusNode;
    }
    
    
    /**
     * alias for _todos setter
     */
    public function setTodos($values)
    {
        return $this->set_todos($values);
    }
    
    /**
     * alias for _todos getter
     */
    public function getTodos()
    {
        return $this->get_todos();
    }
        
    /**
     * Get employee by username and password
     * 
     * @param array $parameters 
     * @return Carerix_Api_Rest_Entity_Employee
     * 
     * @see http://development.wiki.carerix.com/index.php/Cxrest_API_methods#GET_employee.2Fget-by
     * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
     */    
    public static function getBy(array $parameters)
    {
        $action = 'get-by';
        $get_called_class = get_called_class();
        return self::$_manager->execute(
            $get_called_class,
            self::generateUrl(get_defined_vars(), $get_called_class),
            Carerix_Api_Rest_Client::GET,
            $parameters
        );
    }
    
    /**
     * Create or modify an employee object and perform additional tasks in one go. 
     * 
     * @param array $parameters [optional]
     * @return Carerix_Api_Rest_Entity_Employee
     * 
     * @see http://development.wiki.carerix.com/index.php/Cxrest_API_methods#POST_employee.2Fapply
     * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
     */        
    public function apply($parameters = null)
    {
        return $this->post('apply', $parameters);
    }
    
    /**
     * (non-PHPdoc)
     * @see Carerix_Api_Rest_Entity::subscribe()
     * @return Carerix_Api_Rest_Entity_Employee
     */
    public function subscribe($parameters = null, $hydrate = null)
    {
        return parent::subscribe($parameters, $hydrate);    
    }    

}