<?php
/**
 * Carerix PHP Library
 *
 * LICENSE
 *
 * This source file is subject to the LGPL license that is 
 * available through the world-wide-web at this URL:
 * http://www.opensource.org/licenses/lgpl-license.php
 *
 * @category Carerix
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 * @copyright Copyright (c) 2012 Carerix.com (http://www.carerix.com)
 * @license http://www.opensource.org/licenses/lgpl-license.php  LGPL
 * @link http://www.carerix.com
 * @version 2012-05-30 16:49:04Z
 */
 
/**
 * lcfirst method missing in PHP 5.2
 * 
 * @author Andrey Yakubovskiy <andrey.yakubovskiy@gmail.com>
 */
if(!function_exists('lcfirst')) {
    function lcfirst($str) {
        return substr_replace($str, strtolower(substr($str, 0, 1)), 0, 1);
    }
}

/**
 * Late static binding support for PHP 5.2
 * params in method on a called class should be declared on one line, e.g.
 * 
 * someCalledClass::get($p1, p2);
 * 
 * otherwise, the called class won't be detected. this is won't work
 * 
 * someCalledClass::get(
 *      $p1, 
 *      p2
 * );
 */
if(!function_exists('get_called_class')) {
    class class_tools {
        static $i = 0;
        static $fl = null;

        static function get_called_class() {
            $bt = debug_backtrace();

            if (self::$fl == $bt[2]['file'].$bt[2]['line']) {
                self::$i++;
            } else {
                self::$i = 0;
                self::$fl = $bt[2]['file'].$bt[2]['line'];
            }

            $lines = @file($bt[2]['file']);
            if($lines === false) {
                throw new Exception('Unable to determine get_called_class.');
            }

            preg_match_all('/([a-zA-Z0-9\_]+)::'.$bt[2]['function'].'/', $lines[$bt[2]['line']-1], $matches);

            return $matches[1][self::$i];
        }
    }

    function get_called_class() {
        return class_tools::get_called_class();
    }
}